library throttle;

import 'dart:async';

class Throttle<S, T> extends StreamEventTransformer {

  final Duration _delay;

  const Throttle(this._delay);

  Stream<T> bind(Stream<S> stream) {
    var controller   = new StreamController();
    var subscription = null;
    subscription     = stream.listen(
      (S data) {
        controller.add(data);
        subscription.pause();
        new Timer(this._delay, () {
          subscription.resume();
        });
      },
      onError: (error) {
        controller.addError(error);
      },
      onDone: () {
        controller.close();
      }
    );
    return controller.stream;
  }

}